/*
 WARNING: Experimental code!
 
	Though the source code is provided, I do not recommend using it!
	The following is simply an experiment.
	There will be major improvements made before it’s officially released.
	For the latest stable release refer to the project page (www.brian2000.com/projects).
	
	In other words, don't use this as there will be fresher code on my site
*/

/*!
 *
 * Brian2000: BK_GameEngine v0.0000001
 * Notes: Experimental
 * Features: Basic collision detection, simple sprites, sprite movement, keyboard detection, basic environment. 
 * Uses:  HTML 5’s canvas element.

 * http://brian2000.com
 *
 * Copyright 2012, Brian Kennedy
 * Licensed under the GPL Version 3 license
 * http://www.gnu.org/licenses/gpl-3.0.en.html
 *
 * Date: Wed Aug 29 2012 7:07PM EST  
 *
 * You can't remove this part, and if you make changes or improve things, please keep me informed
 * Thank you, enjoy, and support Open Source.
 */
/////////////////////////////////////////////////////
// ENVIRONMENT 
function AerialEnvironment(){
	this.SpriteList = new Array(defaultSprite = new BK_Sprite());
	this.var1 = 't';
	console.log(this.var1);
	
	this.display = function(sprite){
		sprite.draw();		
	}
	//redraws the screen

}
function refreshLoop(env){
		context.clearRect(0, 0, canvas.width, canvas.height); //clear canvas
		//refresh element states
		for (var i = 0; i < env.SpriteList.length; i++) {
			env.display(env.SpriteList[i]);
		}
	}	

/////////////////////////////////////////////////////
// KEYBOARD
var CurrentKey = 0;
var CurrentSpeed = 0;

function keyUp(e) {
	CurrentKey = 0;
	CurrentSpeed = 0;
}
function keyPress(e){
	keyCode = (e.keyCode ? e.keyCode : e.which);  
	if(keyCode === 37){
		CurrentKey = 'L';
		defaultSprite.direction('L');
	}
	if(keyCode === 38){
		CurrentKey = 'U';
		defaultSprite.direction('U');
	}
	if(keyCode === 39){
		CurrentKey = 'R';
		defaultSprite.direction('R');
	}
	if(keyCode === 40){
		CurrentKey = 'D';
		defaultSprite.direction('D');
	}
	//CurrentSpeed = CurrentSpeed+TileSize;
	cords = moveSprite(defaultSprite.x,defaultSprite.y,CurrentKey,CurrentSpeed);
	if(cords){
		defaultSprite.pos(cords);
	}
}
/////////////////////////////////////////////////////
// SPRITES
function BK_Sprite(){
	//cords and speed
	this.x = 25;
	this.y = 25;
	this.s = 0;
	//state
	this.left = '[--';
	this.right = '--]';
	this.center = '[+]';
	this.up = '[^]';
	this.down = '[_]';
	this.defaultState = this.center;
	this.state = this.defaultState;
	this.lastStateChange = 0;
	this.defaultResetInterval = 30;
	
	//update function for relocating a sprite.
	//this will literaly teleport a sprite!
	//use movement for collision and speed algorithims
	//to evaluate where to put sprite and set it with this function
	this.pos = function(arrayCords){		
		this.x = arrayCords[0];
		this.y = arrayCords[1];
		this.lastStateChange = 0;
	}
	this.draw = function(){
		this.lastStateChange = this.lastStateChange + 1;
		if(this.lastStateChange >= this.defaultResetInterval){
			this.state = this.defaultState;
		}
		context.font="30px Arial";
		context.fillText(this.state, this.x , this.y);
	}
	this.speed = function(){
		
	}
	//changes the direction of the sprite
	this.direction = function(dir){
		switch(dir){
			case 'U':
				this.state = this.up;
			  break;
			case 'D':
				this.state = this.down;
			  break;
			case 'R':
				this.state = this.right;
			  break;
			case 'L':
				this.state = this.left;
			  break;
			}
		}
	this.debug = function(){
		console.log('SPRITE| x,y,s = ' +  this.x + ',' + this.y + ',' + this.s + '| lastStateChange ' + this.lastStateChange);
	}
}
/////////////////////////////////////////////////////
// MOVEMENT
// Movement section will handle collision detection (clipping), and speed dynamics

//moveSprit will return the location of where a sprite is being moved to, will also handle speed and clipping 
function moveSprite(x, y, direction, speed){
	//Speed is integer of how many tiles to move at a time
	//speed = speed - 1;
	console.log(speed);
	switch(direction)
	{
	case 'U':
		y = y - TileSize - speed; 
	  break;
	case 'D':
		y = y + TileSize + speed; 
	  break;
	case 'R':
		x = x + TileSize + speed; 
	  break;
	case 'L':
		x = x - TileSize - speed; 
	  break;
	}
	if(!clip(x,y)){
		return(new Array(x,y));
	}
}
function clip(x, y){
	//clip detection
	//edge of screen detection
	if(x>800 || x < 0){
		return true;
	}
	if(y > 500 || y < 0){
		return true;
	}
	return false;
}
